###################################################
### chunk number 1: seed
###################################################
#line 126 "SweaveInput"
set.seed(123)


###################################################
### chunk number 2: Hello world
###################################################
#line 189 "SweaveInput"
print("Hello world!")
1+1
1 + sin(9)
234/87754
(1 + 0.05)^8
23.76*log(8)/(23 + atan(9))


###################################################
### chunk number 3: assign
###################################################
#line 215 "SweaveInput"
x = sin(9)/75
y = log(x) + x^2
x
y
m <- matrix(c(1,2,4,1), ncol=2)
m
solve(m)


###################################################
### chunk number 4: list objects
###################################################
#line 227 "SweaveInput"
ls()


###################################################
### chunk number 5: list objects with pattern
###################################################
#line 233 "SweaveInput"
x2 = 9
y2 = 10
ls(pattern="x")


###################################################
### chunk number 6: remove
###################################################
#line 241 "SweaveInput"
rm(x, x2)


###################################################
### chunk number 7: My first scatterplot
###################################################
#line 247 "SweaveInput"
z2 <- c(1,2,3,4,5,6)
z3 <- c(6,8,3,5,7,1)
plot(z2,z3)
title("My first scatterplot")


###################################################
### chunk number 8: 
###################################################
#line 255 "SweaveInput"
plot(z2,z3)
title("My first scatterplot")


###################################################
### chunk number 9: RSiteSearch
###################################################
#line 319 "SweaveInput"
RSiteSearch("robust")


###################################################
### chunk number 10: setwd
###################################################
#line 336 "SweaveInput"
setwd("C:\\")


###################################################
### chunk number 11: save image
###################################################
#line 340 "SweaveInput"
## save to the current working directory
save.image()
## just checking what the current working directory is
getwd()
## save to a specific file and location
save.image("C:\\RIntroductoryCourse.RData")


###################################################
### chunk number 12: search
###################################################
#line 363 "SweaveInput"
search()


###################################################
### chunk number 13: library
###################################################
#line 369 "SweaveInput"
exists("shoes")
library(MASS)
exists("shoes")
shoes


###################################################
### chunk number 14: library2
###################################################
#line 378 "SweaveInput"
library()


###################################################
### chunk number 15: sessionInfo
###################################################
#line 386 "SweaveInput"
sessionInfo()


###################################################
### chunk number 16: maskedobjects
###################################################
#line 396 "SweaveInput"
sum
sum = 10
sum


###################################################
### chunk number 17: conflicts
###################################################
#line 404 "SweaveInput"
conflicts()


###################################################
### chunk number 18: help
###################################################
#line 527 "SweaveInput"
help(c)


###################################################
### chunk number 19: double
###################################################
#line 544 "SweaveInput"
x <- 8.14
y <- 8.0
z <- 87.0 + 12.9


###################################################
### chunk number 20: typeof
###################################################
#line 554 "SweaveInput"
typeof(x)
is.double(8.9)
test <- 1223.456
is.double(test)
is.numeric(test)
is.real(test)


###################################################
### chunk number 21: testdouble
###################################################
#line 567 "SweaveInput"
0.3 == 0.1 + 0.1 + 0.1


###################################################
### chunk number 22: character
###################################################
#line 577 "SweaveInput"
x <- c("a","b","c")
x
mychar1 <- "This is a test"
mychar1
mychar2 <- "This is another test"
mychar2
charvector <- c("a", "b", "c", "test")
charvector


###################################################
### chunk number 23: logical
###################################################
#line 599 "SweaveInput"
x <- 9
y <- x > 10
y


###################################################
### chunk number 24: logical2
###################################################
#line 607 "SweaveInput"
is.double(9.876)


###################################################
### chunk number 25: logical3
###################################################
#line 624 "SweaveInput"
x <- c(9,166)
y <- (3 < x) & (x <= 10)


###################################################
### chunk number 26: logical4
###################################################
#line 631 "SweaveInput"
x <- 1:15
## number of elements in x larger than 9
sum(x>9)


###################################################
### chunk number 27: integer
###################################################
#line 643 "SweaveInput"
nchild <- as.integer(3)
is.integer(nchild)


###################################################
### chunk number 28: integertest
###################################################
#line 650 "SweaveInput"
nchild  <- 3.0
is.integer(nchild)
nchild <- 3
is.integer(nchild)


###################################################
### chunk number 29: integeroperations
###################################################
#line 659 "SweaveInput"
x <- as.integer(7)
y <- 2.0
z <- x/y
z


###################################################
### chunk number 30: maxinteger
###################################################
#line 668 "SweaveInput"
as.integer(2^31 - 1)
as.integer(2^31)


###################################################
### chunk number 31: factor
###################################################
#line 694 "SweaveInput"
sex <- c("male","male","female","male","female")


###################################################
### chunk number 32: factor2
###################################################
#line 700 "SweaveInput"
sex <- factor(sex)
sex


###################################################
### chunk number 33: factor3
###################################################
#line 709 "SweaveInput"
levels(sex)


###################################################
### chunk number 34: factor4
###################################################
#line 715 "SweaveInput"
sex <- c(2,2,1,2,1)


###################################################
### chunk number 35: factor5
###################################################
#line 721 "SweaveInput"
sex <- factor(sex)
sex


###################################################
### chunk number 36: factor6
###################################################
#line 728 "SweaveInput"
sex + 7


###################################################
### chunk number 37: factor7
###################################################
#line 734 "SweaveInput"
levels(sex) <- c("female", "male")
sex


###################################################
### chunk number 38: factor8
###################################################
#line 741 "SweaveInput"
sex.numeric <- as.double(sex)
sex.numeric


###################################################
### chunk number 39: orderedfactor
###################################################
#line 750 "SweaveInput"
Income <- c("High","Low","Average","Low","Average","High","Low")
Income <- ordered(Income, levels=c("Low","Average","High"))
Income


###################################################
### chunk number 40: orderedfactor
###################################################
#line 758 "SweaveInput"
Income.numeric  <- as.double(Income)
Income.numeric


###################################################
### chunk number 41: date
###################################################
#line 770 "SweaveInput"
temp <- c("01-01-2000", "31-03-2000")
z <- as.Date(temp, "%d-%m-%Y")
z
data.class(z)
format(z, "%Y-%m-%d")


###################################################
### chunk number 42: date1
###################################################
#line 780 "SweaveInput"
z + 19


###################################################
### chunk number 43: date2
###################################################
#line 786 "SweaveInput"
dz = z[2] -z[1]
dz
data.class(dz)


###################################################
### chunk number 44: POSIXct
###################################################
#line 797 "SweaveInput"
t1 <- as.POSIXct("2000-01-01")
t2 <- as.POSIXct("2000-03-31 15:34")
t1
t2


###################################################
### chunk number 45: POSIXct1
###################################################
#line 808 "SweaveInput"
# first creating four characters
x <- c("01/01/2000", "01/02/2000", "03/31/2000", "07/30/2000")
z <- strptime(x, "%m/%d/%Y")
zt <- as.POSIXct(z)
zt


###################################################
### chunk number 46: POSIXct2
###################################################
#line 816 "SweaveInput"
# pasting 4 character dates and 4 character times together
dates <- c("01/01/2000", "01/02/2000", "03/31/2000", "07/30/2000")
times <- c("23:03:20", "22:29:56", "01:03:30", "18:21:03")
x <- paste(dates, times)
z <- strptime(x, "%m/%d/%Y %H:%M:%S")
zt <- as.POSIXct(z, tz = "GMT")
zt


###################################################
### chunk number 47: POSIXct3
###################################################
#line 828 "SweaveInput"
zt + 13


###################################################
### chunk number 48: POSIXct4
###################################################
#line 836 "SweaveInput"
t2 <- as.POSIXct("2000-01-01 23:03:20")
t1 <- as.POSIXct("2000-03-31 01:03:30")
d <- t2-t1
d


###################################################
### chunk number 49: POSIXct5
###################################################
#line 847 "SweaveInput"
"+.POSIXt"(zt, d)


###################################################
### chunk number 50: weekdays
###################################################
#line 855 "SweaveInput"
weekdays(zt)


###################################################
### chunk number 51: complex
###################################################
#line 867 "SweaveInput"
test1 <- as.complex(-1)
test1
sqrt(test1)
typeof(test1)


###################################################
### chunk number 52: na nan
###################################################
#line 884 "SweaveInput"
x <- as.double( c("1", "2", "qaz"))
is.na(x)
z <- sqrt(c(1,-1))
is.nan(z)


###################################################
### chunk number 53: inf
###################################################
#line 895 "SweaveInput"
x <- c(1,3,4)
y <- c(1,0,4)
x/y
z <- log(c(4,0,8))
is.infinite(z)


###################################################
### chunk number 54: vector
###################################################
#line 930 "SweaveInput"
x <- c(10, 5, 3, 6)
x


###################################################
### chunk number 55: vector2
###################################################
#line 937 "SweaveInput"
y <- c(x,0.55, x, x)
y


###################################################
### chunk number 56: round
###################################################
#line 948 "SweaveInput"
round (y,3)  # round to 3 decimals


###################################################
### chunk number 57: calculations
###################################################
#line 957 "SweaveInput"
x
z <- x*x
z


###################################################
### chunk number 58: log
###################################################
#line 966 "SweaveInput"
log(x)


###################################################
### chunk number 59: recycle
###################################################
#line 998 "SweaveInput"
sqrt(x) + 2


###################################################
### chunk number 60: recycle2
###################################################
#line 1004 "SweaveInput"
x <- c(1,2,3,4)
y <- c(1,2,3,4,5,6)
z <- x*y 
z


###################################################
### chunk number 61: seq
###################################################
#line 1016 "SweaveInput"
index <- 1:20
index


###################################################
### chunk number 62: seq2
###################################################
#line 1023 "SweaveInput"
u <- seq(from=-3,to=3,by =0.5)
u


###################################################
### chunk number 63: seq3
###################################################
#line 1030 "SweaveInput"
u <- seq(-3,3,length=13)
u
u <- (-6):6/2
u


###################################################
### chunk number 64: seq4
###################################################
#line 1039 "SweaveInput"
seq(as.POSIXct("2000-01-01"), by = "month", length = 6)
seq(ISOdate(2000,1,1), ISOdate(2005,6,1), "years")


###################################################
### chunk number 65: rep
###################################################
#line 1048 "SweaveInput"
rep(1:4, 4)
rep(1:4, each = 4)


###################################################
### chunk number 66: rep2
###################################################
#line 1055 "SweaveInput"
rep(1:4, c(2,2,2,2))
rep(1:4, 1:4)


###################################################
### chunk number 67: rand
###################################################
#line 1062 "SweaveInput"
x <- rnorm(10)			# 10 random standard normal numbers
y <- runif(10,4,7)	# 10 random numbers between 4 and 7


###################################################
### chunk number 68: matrix
###################################################
#line 1080 "SweaveInput"
x <- matrix(1:8,2,4,byrow=F)
x


###################################################
### chunk number 69: dim
###################################################
#line 1092 "SweaveInput"
x <- 1:8
x
dim(x) <- c(2,4)
x


###################################################
### chunk number 70: bind
###################################################
#line 1103 "SweaveInput"
cbind(c(1,2,3),c(4,5,6))
rbind(c(1,2,3),c(4,5,6))


###################################################
### chunk number 71: matrixoperations
###################################################
#line 1111 "SweaveInput"
x*x^2   # All operations are applied on each matrix element
max(x)  # returns the maximum of all matrix elements in x


###################################################
### chunk number 72: matrixoperations1
###################################################
#line 1118 "SweaveInput"
x <- matrix(1:16,ncol=4)
y <- 7:10
x*y
x <- matrix(1:28,ncol=4)
y <- 7:10
x*y


###################################################
### chunk number 73: matrixoperations2
###################################################
#line 1131 "SweaveInput"
x <- matrix(1:8,ncol=2) 
print(try(x %*% x))


###################################################
### chunk number 74: matrixoperations2
###################################################
#line 1140 "SweaveInput"
x %*% t(x)


###################################################
### chunk number 75: array
###################################################
#line 1178 "SweaveInput"
dim(iris3)   # dimensions of iris 


###################################################
### chunk number 76: array1
###################################################
#line 1184 "SweaveInput"
test <- iris + 2*iris


###################################################
### chunk number 77: array2
###################################################
#line 1192 "SweaveInput"
newarray <- array(c(1:8, 21:28, 331:338), dim = c(2,4,3))
newarray


###################################################
### chunk number 78: dataframe
###################################################
#line 1205 "SweaveInput"
head(mtcars) # only the first rows of a data.frame


###################################################
### chunk number 79: dataframe1
###################################################
#line 1214 "SweaveInput"
rownames(mtcars)[1:5] # only the first five row names
names(mtcars)
colnames(mtcars)


###################################################
### chunk number 80: dataframe2
###################################################
#line 1225 "SweaveInput"
my.logical <- sample(c(T,F),size=5,replace = T) 
my.numeric <- rnorm(5)
my.df <- data.frame(my.logical,my.numeric)
my.df
my.df <- data.frame(Logical = my.logical, Numeric = my.numeric)
my.df
test <- matrix(runif(15, 0, 100),5,3) # create a matrix with random elements
test <- data.frame(test)
test
names(test)


###################################################
### chunk number 81: dataframe2
###################################################
#line 1240 "SweaveInput"
names(test) <- c("Price", "Length", "Income")
row.names(test) <- c("Paul","Ian","Richard","David","Rob")
test


###################################################
### chunk number 82: ts
###################################################
#line 1257 "SweaveInput"
# starting from jan-2000, 12 monthly intervals 
myts1 <- ts(data = rnorm(12), start=c(2000), freq = 12)
# two time-series starting from mar-2000, 3 monthly intervals
myts2 <- ts(data = matrix(rnorm(6),ncol=2), start=c(2000,3), freq=12)
myts2


###################################################
### chunk number 83: tsp
###################################################
#line 1269 "SweaveInput"
tsp(myts2)


###################################################
### chunk number 84: list
###################################################
#line 1279 "SweaveInput"
x <- 1:5
y <- x + rnorm(5,0,0.25)
z <- lsfit(x,y)
z


###################################################
### chunk number 85: list1
###################################################
#line 1296 "SweaveInput"
test <- z$r
test
z$r[4]  # fourth element of the residuals


###################################################
### chunk number 86: list2
###################################################
#line 1305 "SweaveInput"
x1 <- 1:5
x2 <- c(T,T,F,F,T)
y <- list(numbers=x1, wrong=x2)
y


###################################################
### chunk number 87: list3
###################################################
#line 1314 "SweaveInput"
y[[2]]


###################################################
### chunk number 88: list4
###################################################
#line 1320 "SweaveInput"
names(y)
names(y) <- c("lots", "valid")
names(y)


###################################################
### chunk number 89: list5
###################################################
#line 1328 "SweaveInput"
y[[3]] <- 1:10
y$test <- "hello"
y


###################################################
### chunk number 90: list6
###################################################
#line 1336 "SweaveInput"
y[1]
y[[1]]


###################################################
### chunk number 91: list7
###################################################
#line 1347 "SweaveInput"
as.list(1:3)


###################################################
### chunk number 92: str
###################################################
#line 1358 "SweaveInput"
x1 <- rnorm(100)
x2 <- matrix(rnorm(800),ncol=80)
myl1 <- list(x1,x2,my.df)

str(x1)
str(x2)
str(my.df)
str(myl1)


###################################################
### chunk number 93: readtable
###################################################
#line 1400 "SweaveInput"
myfile <- "C:\\PROJECTS\\RIntroductoryCourse\\Data.txt"
mydf <- read.table(myfile, skip=3, sep=",", header=TRUE)
mydf


###################################################
### chunk number 94: readtable1
###################################################
#line 1408 "SweaveInput"
mydf <- read.table(
          myfile, 
          skip=3,
          sep=",",
          header=TRUE,
          stringsAsFactors=FALSE)


###################################################
### chunk number 95: readtable2
###################################################
#line 1419 "SweaveInput"
mydf <- read.table(
          myfile, skip=3, sep=",", 
          header=TRUE, stringsAsFactors=FALSE,
          colClasses = c("numeric", "numeric", "factor", "character"))


###################################################
### chunk number 96: readtable3
###################################################
#line 1439 "SweaveInput"
myfile <- "C:\\PROJECTS\\RIntroductoryCourse\\Data.csv"
read.csv(myfile, quote="'")


###################################################
### chunk number 97: scan
###################################################
#line 1451 "SweaveInput"
scan(myfile, what="character", sep=",", strip.white =TRUE)


###################################################
### chunk number 98: subscript
###################################################
#line 1580 "SweaveInput"
x <- c(6,7,2,4)
x[1]    
x[length(x)]


###################################################
### chunk number 99: subscript1
###################################################
#line 1592 "SweaveInput"
x
x[1:3]


###################################################
### chunk number 100: subscript2
###################################################
#line 1599 "SweaveInput"
x[c(4,1,4)] 


###################################################
### chunk number 101: subscript3
###################################################
#line 1605 "SweaveInput"
x[3] <- 4


###################################################
### chunk number 102: subscriptlogical
###################################################
#line 1624 "SweaveInput"
x <- c(10,4,6,7,8)
y <- x >9      
y 
x[y]           


###################################################
### chunk number 103: subscriptlogical1
###################################################
#line 1633 "SweaveInput"
x[x>9]


###################################################
### chunk number 104: matrixsubscript
###################################################
#line 1780 "SweaveInput"
x <- matrix(1:36, ncol=6)
## the element in row 2 and column 6 of x
x[2,6]  				
## the third row of x
x[3, ]  	
## the element in row 3 and column 1 and 
## the element in row 3 and column 5
x[3,c(1,5)] 		
## show x, except for the first column
x[,-1] 			


###################################################
### chunk number 105: matrixsubscript2
###################################################
#line 1795 "SweaveInput"
x[-3,-4]


###################################################
### chunk number 106: matrixsubscript3
###################################################
#line 1801 "SweaveInput"
x <- x[-3,4]


###################################################
### chunk number 107: matrixsubscript4
###################################################
#line 1807 "SweaveInput"
x <- matrix(1:36, ncol=6)
x[4,5] <- 5


###################################################
### chunk number 108: matrixsubscript5
###################################################
#line 1814 "SweaveInput"
x <- matrix(rnorm(100),ncol=10)
x[ ,1] <- 1:10


###################################################
### chunk number 109: mtcars
###################################################
#line 1895 "SweaveInput"
names(mtcars)


###################################################
### chunk number 110: mtcars1
###################################################
#line 1901 "SweaveInput"
mpg <- cars$mpg
mpg <- cars[["mpg"]]


###################################################
### chunk number 111: mtcars2
###################################################
#line 1908 "SweaveInput"
mpg2 <- mtcars["mpg"]


###################################################
### chunk number 112: mtcars3
###################################################
#line 1914 "SweaveInput"
test <- mtcars[c("mpg","cyl")]


###################################################
### chunk number 113: mtcars4
###################################################
#line 1920 "SweaveInput"
mtcars["Volvo 142E", ]


###################################################
### chunk number 114: mtcars5
###################################################
#line 1926 "SweaveInput"
mtcars[c("Volvo 142E", "Fiat X1-9"), ]


###################################################
### chunk number 115: mtcars6
###################################################
#line 1932 "SweaveInput"
mtcars["Lada",]


###################################################
### chunk number 116: mtcars7
###################################################
#line 1939 "SweaveInput"
mtcars[10:14,]


###################################################
### chunk number 117: mtcars8
###################################################
#line 1949 "SweaveInput"
head(mtcars,3)
tail(mtcars,2)


###################################################
### chunk number 118: mtcars9
###################################################
#line 1959 "SweaveInput"
tmp <- mtcars$cyl > 6


###################################################
### chunk number 119: mtcars10
###################################################
#line 1965 "SweaveInput"
mtcars[tmp, ]


###################################################
### chunk number 120: mtcars11
###################################################
#line 1974 "SweaveInput"
subset(mtcars, cyl > 6 & hp > 250)


###################################################
### chunk number 121: quantile
###################################################
#line 2587 "SweaveInput"
x <- rnorm(100)
xq <- quantile(x,c(0.05, 0.5, 1)) 
xq


###################################################
### chunk number 122: summary
###################################################
#line 2598 "SweaveInput"
summary(mtcars)


###################################################
### chunk number 123: lmmtcars
###################################################
#line 2630 "SweaveInput"
fit <- lm(100/mpg ~ hp + wt, data=mtcars)
fit


###################################################
### chunk number 124: lmmtcars1
###################################################
#line 2637 "SweaveInput"
summary(fit)


###################################################
### chunk number 125: lmmtcars2
###################################################
#line 2643 "SweaveInput"
plot(fit,  which = 2)


